﻿EnableExplicit

XIncludeFile "ALI.pbi"
XIncludeFile "RSA-Schlüsselgenerator.pbf"

Dim ret.a(2500)
Global *ret = @ret()
  
Global rsastr.s, expoEstr.s, expoDstr.s, seed.s
Global event, jj, processing, Path$ = GetCurrentDirectory() ; GetUserDirectory(#PB_Directory_Documents)

#UseSeed = 0    ; hier ändern 1 oder 0

; testen, ob die DLL im System-Ordner, im Programm-Verzeichnis oder im aktuellen Verzeichnis auffindbar ist
Define hdl.l = ALI_LoadDLL()
If Not hdl
  MessageRequester("Error:", "'ALI.dll' not found")
  End
EndIf
ALI_CloseDLL(hdl)


Procedure GenerateSeed()
  ; Seed generieren
  Protected X.l
  Protected Y.l
  Protected ii.l
  Protected tmp.a
  Protected iiold.l = 65536 ; dieser Wert kommt bei ii nie vor 
  Protected *Buffer = AllocateMemory(65536)
  ; Schlüssel-Erzeugen-Fenster öffnen
  Protected MouseWindow = OpenWindow(#PB_Any, 0, 0, 256, 256, "RSA-Schlüsselgenerator", #PB_Window_ScreenCentered)
;  TextGadget(#PB_Any, 10, 6, 236, 40, "Um den Zufall unabhängig vom Computer zu machen bewegen Sie die Maus über dieses Fenster.")
  TextGadget(#PB_Any, 10, 6, 236, 40, "Bewegen Sie die Maus über dieses Fenster um die Schlüssel weniger deterministisch zu machen.")
  ; den Buffer mit Zufallzahlen füllen
  If OpenCryptRandom() And *Buffer
    CryptRandomData(*Buffer, 65536)
    CloseCryptRandom()
  Else
    MessageRequester("Error", "Seed generation is not available")
    End
  EndIf
  ; Die Positionen während der Mausbewegung ermitteln und
  ; die entsprechenden Zufallzahlen aus dem Buffer in die Keyliste eintragen.
  seed = ""
  Repeat
    WindowEvent()
    X = WindowMouseX(MouseWindow)
    Y = WindowMouseY(MouseWindow)
    ii = X + (Y * 256)
    If (X > -1) And (X < 256) And (Y > -1) And (Y < 256) And (ii <> iiold) ; nur auf dem Seed-Fenster
      tmp = PeekA(*Buffer + ii)  ; tmp = 0...255
      If tmp > 99 : tmp - 100 : EndIf   ; tmp = 0...156
      If tmp < 100 : seed + RSet(Str(tmp), 2, "0") : EndIf  ; tmp = 0...99
      iiold = ii
    EndIf    
    Delay(20)
  Until Len(seed) > 153 ; anfängliche Anzahl der Dezimalstellen festlegen
  FreeMemory(*Buffer)
  MessageRequester("RSA-Schlüsselgenerator", "Danke, das war's schon.")
  CloseWindow(MouseWindow)
EndProcedure


If #UseSeed : GenerateSeed() : EndIf
OpenMainWindow()
;256, 512, 768, 1024, 1280, 1536, 1792, 2048, 2304, 2560, 2304, 2460, 2816, 3072, 3328, 3584, 3840, 4096
SetGadgetState (spiLength, 8) : SetGadgetText(spiLength, "2048") 


Procedure turnSpinner(EventType)
  ; Spinner-Eingaben ändern
  SetGadgetText(spiLength, Str(GetGadgetState(spiLength) * 256))
  SetActiveGadget(-1) ; entfernt den blauen Hintergrund
EndProcedure  


Procedure.s phiN(p.s, q.s)
  ; phi(N) erzeugen
  Protected ptmp.s, qtmp.s
  zzsub(*ret, p, "1")
  ptmp = PeekS(*ret, -1, #PB_Ascii)
  zzsub(*ret, q, "1")
  qtmp = PeekS(*ret, -1, #PB_Ascii)
  zzmul(*ret, ptmp, qtmp)
  ProcedureReturn PeekS(*ret, -1, #PB_Ascii)
EndProcedure


Procedure.s findE(phin.s)
  ; findet den Verschlüsselungsexponent e
  Protected ii.l, leng.l, nbr.s
  leng = zznob(phin) - 2     ; die Anzahl Bits von e muss etwas kleiner sein als phi(N)
  For ii = 0 To 100
    zzrnd(*ret, leng)        ; Zufallzahl erzeugen
    nbr = PeekS(*ret, -1, #PB_Ascii)
    zzgcd(*ret, phin, nbr)
    If PeekS(*ret, -1, #PB_Ascii) = "1"
      ProcedureReturn nbr
    EndIf  
  Next 
  ProcedureReturn ""
EndProcedure


Procedure createRSAkey(par)
  ; neues Schlüsselpaar erzeugen
  If processing : ProcedureReturn : EndIf
  processing = #True
  Protected hdl.l = ALI_LoadDLL()
  If Not hdl : processing = #False : ProcedureReturn : EndIf
  Protected leng.l = GetGadgetState(spiLength) * 128
  Protected pristr1.s, pristr2.s, phistr.s, ctext.s
  ; clr Textfelder
  SetGadgetText(ediPrim1, "")
  SetGadgetText(ediPrim2, "")
  SetGadgetText(ediRSAmdl, "")
  SetGadgetText(ediPhiN, "")
  SetGadgetText(ediExpoE, "")
  SetGadgetText(ediExpoD, "")
  ;
  If #UseSeed : zzsee(seed) : EndIf     ; den selbst erzeugten Startwert setzen            
  zzpri(*ret, leng)                     ; 1. Primzahl erzeugen
  pristr1 = PeekS(*ret, -1, #PB_Ascii)
  SetGadgetText(ediPrim1, pristr1)
  zzpri(*ret, leng)                     ; 2. Primzahl erzeugen
  pristr2 = PeekS(*ret, -1, #PB_Ascii)
  SetGadgetText(ediPrim2, pristr2)
  zzmul(*ret, pristr1, pristr2)         ; RSA-Modul (N) erzeugen
  rsastr = PeekS(*ret, -1, #PB_Ascii)
  SetGadgetText(ediRSAmdl, rsastr)
  phistr = phiN(pristr1, pristr2)       ; phi(N) erzeugen
  SetGadgetText(ediPhiN, rsastr)
  expoEstr = findE(phistr)              ; e erzeugen
  If expoEstr <> ""
    SetGadgetText(ediExpoE, expoEstr)
    zzpom(*ret, expoEstr, "-1", phistr)  ; x = w1^-1 % w3    das multiplikative Inverse berechnen
    expoDstr = PeekS(*ret, -1, #PB_Ascii)
    SetGadgetText(ediExpoD, expoDstr)
  EndIf
  If #UseSeed : zzrnd(*ret, leng) : seed = PeekS(*ret, -1, #PB_Ascii) : EndIf
  ALI_CloseDLL(hdl)  
  processing = #False  
EndProcedure  


Procedure startRSA(EventType)
  CreateThread(@createRSAkey(), 0)
EndProcedure


Procedure saveKeys(EventType)
  ; Schlüsselpaar speichern
  If rsastr = "" Or expoEstr = "" Or expoDstr = ""
    MessageRequester("Information", "Erst die Schlüssel erzeugen.", 0) 
    ProcedureReturn
  EndIf
  ;
  Path$ + "Key.rsa" 
  Protected pattern.s = "Text (*.rsa)|*.rsa|Alle Dateien (*.*)|*.*"
  Protected filename.s = SaveFileRequester("Bitte Datei zum Speichern auswählen", Path$, pattern, 0)
  If filename
    Path$ =  GetPathPart(filename)
    Protected fileprivate.s =  Left(filename, Len(filename) - Len(GetExtensionPart(filename)) - 1) + "-private." + GetExtensionPart(filename)
    Protected filepublic.s =  Left(filename, Len(filename) - Len(GetExtensionPart(filename)) - 1) + "-public." + GetExtensionPart(filename)
    If FileSize(fileprivate) <> -1 Or FileSize(filepublic) <> -1
      If MessageRequester("Achtung!", "Mindestens eine der Dateien existiert bereits." + Chr(10) + "Soll sie überschrieben werden?", 
                       #PB_MessageRequester_YesNo | #PB_MessageRequester_Warning) = #PB_MessageRequester_No
          ProcedureReturn
      EndIf    
    EndIf
    
    If CreatePreferences(fileprivate)
      PreferenceComment("Privater RAS-Schlüssel, generiert am " + FormatDate("%dd.%mm.%yyyy  %hh:%ii:%ss", Date()))
      WritePreferenceString ("N", rsastr)
      WritePreferenceString ("d", expoDstr)
      ClosePreferences()
    EndIf  
    If CreatePreferences(filepublic)
      PreferenceComment("Öffentlicher RAS-Schlüssel, generiert am " + FormatDate("%dd.%mm.%yyyy  %hh:%ii:%ss", Date()))
      WritePreferenceString ("N", rsastr)
      WritePreferenceString ("e", expoEstr)
      ClosePreferences()
    EndIf  
  EndIf
EndProcedure  


Procedure Close(EventType)
  End
EndProcedure  

; ---------------------------------
Repeat
  event = WaitWindowEvent(20)
  If Not MainWindow_Events(event)
    Break  ; if event = #PB_Event_CloseWindow
  EndIf 
  If processing
    jj + 1
    If jj = 101 : jj = 0 : EndIf
  Else  
    jj = 0
  EndIf 
  SetGadgetState(Progress, jj)
ForEver
; ---------------------------------


; IDE Options = PureBasic 5.70 LTS (Windows - x64)
; CursorPosition = 5
; Folding = --
; EnableXP